%define anolis_release 1

# Default to no static libraries
%{!?with_static: %global with_static 1}
%bcond_without python
%if %{with python}
%define python_sitearch %(python3 -c "from distutils.sysconfig import get_python_lib; print (get_python_lib(1))")
%define python_prefix %(python3 -c "import sys; print (sys.prefix)")
%{?filter_setup:
%filter_provides_in %{python3_sitearch}/perfmon/.*\.so$
%filter_setup
}
%endif

Name:		libpfm
Version:	4.13.0
Release:	%{anolis_release}%{?dist}
Summary:	Library to encode performance events for use by perf tool
License:	MIT
URL:		http://perfmon2.sourceforge.net/
Source0:	http://sourceforge.net/projects/perfmon2/files/libpfm4/%{name}-%{version}.tar.gz
Patch0:		libpfm-python3-setup.patch

BuildRequires: make
BuildRequires:	gcc
%if %{with python}
BuildRequires:	python3
BuildRequires:	python3-devel
BuildRequires:	python3-setuptools
BuildRequires:	swig
%endif

%description
libpfm4 is a library to help encode events for use with operating system
kernels performance monitoring interfaces. The current version provides support
for the perf_events interface available in upstream Linux kernels since v2.6.31.

%package devel
Summary:	Development library to encode performance events for perf_events based tools
Requires:	%{name} = %{version}-%{release}

%description devel
Development library and header files to create performance monitoring
applications for the perf_events interface.

%if %{with_static}
%package static
Summary:	Static library to encode performance events for perf_events based tools
Requires:	%{name} = %{version}-%{release}

%description static
Static version of the libpfm library for performance monitoring
applications for the perf_events interface.
%endif

%if %{with python}
%package -n python3-libpfm
%{?python_provide:%python_provide python3-libpfm}
Provides: %{name}-python = %{version}-%{release}
Provides: %{name}-python = %{version}-%{release}
Obsoletes: %{name}-python < %{version}-%{release}
Summary:	Python bindings for libpfm and perf_event_open system call
Requires:	%{name} = %{version}-%{release}

%description -n python3-libpfm
Python bindings for libpfm4 and perf_event_open system call.
%endif

%package        doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%setup -q
%patch0 -p1 -b .python3

%build
%if %{with python}
%global python_config CONFIG_PFMLIB_NOPYTHON=n
%else
%global python_config CONFIG_PFMLIB_NOPYTHON=y
%endif
%make_build %{python_config} \
     OPTIM="%{optflags}" LDFLAGS="%{build_ldflags}"

%install
rm -rf $RPM_BUILD_ROOT

%if %{with python}
%global python_config CONFIG_PFMLIB_NOPYTHON=n PYTHON_PREFIX=$RPM_BUILD_ROOT/%{python_prefix}
%else
%global python_config CONFIG_PFMLIB_NOPYTHON=y
%endif

make \
    PREFIX=$RPM_BUILD_ROOT%{_prefix} \
    LIBDIR=$RPM_BUILD_ROOT%{_libdir} \
    %{python_config} \
    LDCONFIG=/bin/true \
    install

%if !%{with_static}
rm $RPM_BUILD_ROOT%{_libdir}/lib*.a
%endif

%generate_compatibility_deps

%files
%{_libdir}/lib*.so.*
%dir %{abidir}
%{abidir}/_perfmon_int.cpython-31*-*-linux-gnu.dump
%{abidir}/libpfm.dump

%files devel
%{_includedir}/*
%{_mandir}/man3/*
%{_libdir}/lib*.so

%if %{with_static}
%files static
%{_libdir}/lib*.a
%endif

%if %{with python}
%files -n python3-libpfm
%{python3_sitearch}/*
%endif

%files doc
%doc README

%changelog
* Tue Feb 18 2025 mgb01105731 <mgb01105731@alibaba-inc.com> - 4.13.0-1
- Update to 4.13.0 from 4.12.0
- Remove patch as the new version of tarball already includes changes.

* Thur Aug 22 2024 tingyin.duan <duanty@sugon.com> - 4.12.0-2
- fix rpmbuild error on Anolis 23.1

* Mon Mar 27 2023 Yuanhong Peng <yummypeng@linux.alibaba.com> - 4.12.0-1
- Init from upstream
